Require Export Omega.
Require Export denot.

Theorem chain_trans :
  forall (A :Set)(R : A -> A -> Prop)(c:nat->A),
  (forall x y z, R x y -> R y z -> R x z) ->
  (forall n, R (c n) (c (S n))) ->
  forall n n', (n < n')%nat ->  R (c n) (c n').
intros A R c Ht Hch n n' Hle; induction Hle.
auto.
apply Ht with (1:= IHHle); auto.
Qed.

(*
Theorem cond_continuous' :
  forall A B C t F G,
    continuous (f_order A B)(f_order A C) F ->
    continuous (f_order A B)(f_order A C) G ->
    continuous (f_order A B)(f_order A bool) t ->
    continuous (f_order A B)(f_order A C) 
       (fun f => cond (t f) (F f)(G f)).
intros A B C t F  G HctF HctG Hctt c Hch l Hlub; split.
intros n x; unfold cond.
caseEq (t l x).
intros [|] Heq.
caseEq (t (c n) x); auto.
intros [|] Heq'.
destruct (HctF c Hch l Hlub) as [Hup _]; apply (Hup n).
assert (abs : option_cpo (Some false)(Some true)).
rewrite <- Heq; rewrite <- Heq'.
destruct (Hctt c Hch l Hlub) as [Hup _]; apply (Hup n).
inversion abs.
auto.
caseEq (t (c n) x); auto.
intros [|] Heq'.
assert (abs : option_cpo (Some true)(Some false)).
rewrite <- Heq; rewrite <- Heq'.
destruct (Hctt c Hch l Hlub) as [Hup _]; apply (Hup n).
inversion abs.
destruct (HctG c Hch l Hlub) as [Hup _]; apply (Hup n).
intros Heq.
assert (option_cpo (t (c n) x) (t l x)).
destruct (Hctt c Hch l Hlub) as [Hup _]; apply (Hup n).
rewrite Heq in H; inversion H; auto.
rewrite H2; auto.

intros l' Hup' x; unfold cond.
caseEq (t l x); auto.
intros [ | ] Heqtlx.
assert (Hlubtl : lub (f_order A bool)(t l)(fun n => t (c n))).
exact (Hctt c Hch l Hlub).
destruct (chain_lub_some_witness _ _ _ x true (t l) Heqtlx Hlubtl)
 as [n Heqtcnx].
assert (HchainF : forall n', option_cpo (F (c n') x) (F (c (S n')) x)).
intros n';
   apply (continuous_imp_monotonic _ _ (f_order A B) (f_order A C) F); auto.
intros g x'; auto.
destruct (complete_option_cpo _ (fun n => F (c n) x) HchainF) as
  [[v'| ] Hlubv'].
destruct (chain_lub_some_witness1 C (fun n => F (c n) x) v' Hlubv')
  as [ n' HeqFcnx].
assert (Hlubtlx : lub (@option_cpo bool) (t l x) (fun n :nat => t (c n) x)).
apply (lub_lift_reverse A _ _ (fun n => t (c n))(t l) Hlubtl).
case (le_gt_dec n n').
intros Hnlen'.
assert (Heqcond : cond (t (c n'))(F (c n'))(G (c n')) x = Some v').
unfold cond.
assert (Heq' : t (c n') x = Some true).
apply option_chain_some_ge with (c:= (fun n=> t (c n) x))
  (n:= n) (m:= n'); auto.
intros n'';
  apply (continuous_imp_monotonic (A->option B)(A->option bool)
                (f_order A B) (f_order A bool) t 
                (f_order_reflexive A B) Hctt (c n'')(c (S n''))).
apply Hch.
rewrite Heq'.
assumption.
assert (HlubFl : lub (f_order A C) (F l) (fun n => F (c n))).
apply HctF; auto.
assert (Hopt :option_cpo (F (c n') x) (F l x)).
destruct HlubFl as [Hup _]; apply (Hup n').
rewrite HeqFcnx in Hopt; inversion Hopt.
rewrite <- Heqcond.
apply (Hup' n' x).

intros Hngtn'.
assert (Heqcond : cond (t (c n))(F (c n))(G (c n)) x = Some v').
unfold cond.
rewrite Heqtcnx.
apply option_chain_some_ge with (c:= (fun n => F (c n) x))
   (n:= n') (m:= n); auto.
auto with arith.
assert (HlubFl : lub (f_order A C) (F l) (fun n => F (c n))).
apply HctF; auto.
assert (Hopt :option_cpo (F (c n') x) (F l x)).
destruct HlubFl as [Hup _]; apply (Hup n').
rewrite HeqFcnx in Hopt; inversion Hopt.
rewrite <- Heqcond.
apply (Hup' n x).

assert (HlubFl : lub (f_order A C) (F l) (fun n => F (c n))).
apply HctF; auto.
assert (HlubFlx : lub (@option_cpo C) (F l x) (fun n => F (c n) x)).
apply (lub_lift_reverse A _ _ (fun n => F (c n))(F l) HlubFl).
assert (Heqflx_none : F l x = None).
apply unique_lub with (1:= antisym_option_cpo C)(2:= HlubFlx)(3:=Hlubv').
rewrite Heqflx_none; auto.

assert (Hlubtl : lub (f_order A bool)(t l)(fun n => t (c n))).
exact (Hctt c Hch l Hlub).
destruct (chain_lub_some_witness _ _ _ x false (t l) Heqtlx Hlubtl)
 as [n Heqtcnx].
assert (HchainG : forall n', option_cpo (G (c n') x) (G (c (S n')) x)).
intros n';
   apply (continuous_imp_monotonic _ _ (f_order A B) (f_order A C) G); auto.
intros g x'; auto.
destruct (complete_option_cpo _ (fun n => G (c n) x) HchainG) as
  [[v'| ] Hlubv'].
destruct (chain_lub_some_witness1 C (fun n => G (c n) x) v' Hlubv')
  as [ n' HeqGcnx].
assert (Hlubtlx : lub (@option_cpo bool) (t l x) (fun n :nat => t (c n) x)).
apply (lub_lift_reverse A _ _ (fun n => t (c n))(t l) Hlubtl).
case (le_gt_dec n n').
intros Hnlen'.
assert (Heqcond : cond (t (c n'))(F (c n'))(G (c n')) x = Some v').
unfold cond.
assert (Heq' : t (c n') x = Some false).
apply option_chain_some_ge with (c:= (fun n=> t (c n) x))
  (n:= n) (m:= n'); auto.
intros n'';
  apply (continuous_imp_monotonic (A->option B)(A->option bool)
                (f_order A B) (f_order A bool) t 
                (f_order_reflexive A B) Hctt (c n'')(c (S n''))).
apply Hch.

rewrite Heq'.
assumption.
assert (HlubGl : lub (f_order A C) (G l) (fun n => G (c n))).
apply HctG; auto.
assert (Hopt :option_cpo (G (c n') x) (G l x)).
destruct HlubGl as [Hup _]; apply (Hup n').
rewrite HeqGcnx in Hopt; inversion Hopt.
rewrite <- Heqcond.
apply (Hup' n' x).

intros Hngtn'.
assert (Heqcond : cond (t (c n))(F (c n))(G (c n)) x = Some v').
unfold cond.
rewrite Heqtcnx.
apply option_chain_some_ge with (c:= (fun n => G (c n) x))
   (n:= n') (m:= n); auto.
auto with arith.
assert (HlubGl : lub (f_order A C) (G l) (fun n => G (c n))).
apply HctG; auto.
assert (Hopt :option_cpo (G (c n') x) (G l x)).
destruct HlubGl as [Hup _]; apply (Hup n').
rewrite HeqGcnx in Hopt; inversion Hopt.
rewrite <- Heqcond.
apply (Hup' n x).

assert (HlubGl : lub (f_order A C) (G l) (fun n => G (c n))).
apply HctG; auto.
assert (HlubGlx : lub (@option_cpo C) (G l x) (fun n => G (c n) x)).
apply (lub_lift_reverse A _ _ (fun n => G (c n))(G l) HlubGl).
assert (Heqflx_none : G l x = None).
apply unique_lub with (1:= antisym_option_cpo C)(2:= HlubGlx)(3:=Hlubv').
rewrite Heqflx_none; auto.
Qed.

Definition F_fact (fact:Z -> option Z) (x:Z) : option Z :=
  match x ?= 0 with
    Eq => Some 1
  | _ => match fact(x - 1) with None => None | Some v => Some (x*v) end
  end.

Theorem F_fact_continuous : continuous (f_order' Z) (f_order' Z) F_fact.
intros c Hchain f Hlub.
split.
intros n x; unfold F_fact;
assert (Hlub_xm1 := lub_lift_reverse _ _ _ c f Hlub (x - 1));
caseEq (x ?= 0);
auto; intros Hcase; caseEq (c n (x - 1)); auto;
(intros v Hcnv1;
destruct Hlub_xm1 as [Hup_xm1 _];
assert (Horder_xm1_n : option_cpo (c n (x-1)) (f (x-1)));
[exact (Hup_xm1 n)|
rewrite Hcnv1 in Horder_xm1_n; inversion Horder_xm1_n; auto]).

intros g Hupg x.

unfold F_fact; caseEq (x?= 0); intros Hcase.
generalize (Hupg 1%nat x).

unfold F_fact; rewrite Hcase; auto.

caseEq (f (x - 1)); auto.
intros v Heqv.
destruct (chain_lub_some_witness  _ _ c _ _ f Heqv Hlub) as [n Heqv'].
generalize (Hupg n x).
unfold F_fact; rewrite Hcase; rewrite Heqv'; auto.

caseEq (f (x - 1)); auto.
intros v Heqv.
destruct (chain_lub_some_witness  _ _ c _ _ f Heqv Hlub) as [n Heqv'].
generalize (Hupg n x).
unfold F_fact; rewrite Hcase; rewrite Heqv'; auto.
Qed.

Definition fact : Z -> option Z :=
  Tarski_fix F_fact F_fact_continuous.
*)


Definition cond (A :Set)
  (t:option bool)(v1 v2:option A) : option A :=
  match t with
    None => None
  | Some true => v1
  | Some false => v2
  end.

Implicit Arguments cond.

Theorem cond_continuous :
  forall A B C t F G,
    continuous (f_order A B) (f_order A bool) t ->
    continuous (f_order A B) (f_order A C) F ->
    continuous (f_order A B) (f_order A C) G ->
    continuous (f_order A B)(f_order A C) 
       (fun f x => cond (t f x) (F f x) (G f x)).
intros A B C t F G Hctt HctF HctG c Hch l Hlub; split.
intros n x; unfold cond.
caseEq (t l x).
intros [|] Heq.
caseEq (t (c n) x); auto.
intros [|] Heq'.
destruct (HctF c Hch l Hlub) as [Hup _]; apply (Hup n).
assert (abs : option_cpo (Some false)(Some true)).
rewrite <- Heq; rewrite <- Heq'.
destruct (Hctt c Hch l Hlub) as [Hup _]; apply (Hup n).
inversion abs.
auto.
caseEq (t (c n) x); auto.
intros [|] Heq'.
assert (abs : option_cpo (Some true)(Some false)).
rewrite <- Heq; rewrite <- Heq'.
destruct (Hctt c Hch l Hlub) as [Hup _]; apply (Hup n).
inversion abs.
destruct (HctG c Hch l Hlub) as [Hup _]; apply (Hup n).
intros Heq.
assert (option_cpo (t (c n) x) (t l x)).
destruct (Hctt c Hch l Hlub) as [Hup _]; apply (Hup n).
rewrite Heq in H; inversion H; auto.
rewrite H2; auto.

intros l' Hup' x; unfold cond.
caseEq (t l x); auto.
intros [ | ] Heqtlx.
assert (Hlubtl : lub (f_order A bool)(t l)(fun n => t (c n))).
exact (Hctt c Hch l Hlub).
destruct (chain_lub_some_witness _ _ _ x true (t l) Heqtlx Hlubtl)
 as [n Heqtcnx].
assert (HchainF : forall n', option_cpo (F (c n') x) (F (c (S n')) x)).
intros n';
   apply (continuous_imp_monotonic _ _ (f_order A B) (f_order A C) F); auto.
intros g x'; auto.
destruct (complete_option_cpo _ (fun n => F (c n) x) HchainF) as
  [[v'| ] Hlubv'].
destruct (chain_lub_some_witness1 C (fun n => F (c n) x) v' Hlubv')
  as [ n' HeqFcnx].
assert (Hlubtlx : lub (@option_cpo bool) (t l x) (fun n :nat => t (c n) x)).
apply (lub_lift_reverse A _ _ (fun n => t (c n))(t l) Hlubtl).
case (le_gt_dec n n').
intros Hnlen'.
assert (Heqcond : cond (t (c n') x)(F (c n') x)(G (c n') x) = Some v').
unfold cond.
assert (Heq' : t (c n') x = Some true).
apply option_chain_some_ge with (c:= (fun n=> t (c n) x))
  (n:= n) (m:= n'); auto.
intros n'';
  apply (continuous_imp_monotonic (A->option B)(A->option bool)
                (f_order A B) (f_order A bool) t 
                (f_order_reflexive A B) Hctt (c n'')(c (S n''))).
apply Hch.
rewrite Heq'.
assumption.
assert (HlubFl : lub (f_order A C) (F l) (fun n => F (c n))).
apply HctF; auto.
assert (Hopt :option_cpo (F (c n') x) (F l x)).
destruct HlubFl as [Hup _]; apply (Hup n').
rewrite HeqFcnx in Hopt; inversion Hopt.
rewrite <- Heqcond.
apply (Hup' n' x).

intros Hngtn'.
assert (Heqcond : cond (t (c n) x)(F (c n) x)(G (c n) x) = Some v').
unfold cond.
rewrite Heqtcnx.
apply option_chain_some_ge with (c:= (fun n => F (c n) x))
   (n:= n') (m:= n); auto.
auto with arith.
assert (HlubFl : lub (f_order A C) (F l) (fun n => F (c n))).
apply HctF; auto.
assert (Hopt :option_cpo (F (c n') x) (F l x)).
destruct HlubFl as [Hup _]; apply (Hup n').
rewrite HeqFcnx in Hopt; inversion Hopt.
rewrite <- Heqcond.
apply (Hup' n x).

assert (HlubFl : lub (f_order A C) (F l) (fun n => F (c n))).
apply HctF; auto.
assert (HlubFlx : lub (@option_cpo C) (F l x) (fun n => F (c n) x)).
apply (lub_lift_reverse A _ _ (fun n => F (c n))(F l) HlubFl).
assert (Heqflx_none : F l x = None).
apply unique_lub with (1:= antisym_option_cpo C)(2:= HlubFlx)(3:=Hlubv').
rewrite Heqflx_none; auto.

assert (Hlubtl : lub (f_order A bool)(t l)(fun n => t (c n))).
exact (Hctt c Hch l Hlub).
destruct (chain_lub_some_witness _ _ _ x false (t l) Heqtlx Hlubtl)
 as [n Heqtcnx].
assert (HchainG : forall n', option_cpo (G (c n') x) (G (c (S n')) x)).
intros n';
   apply (continuous_imp_monotonic _ _ (f_order A B) (f_order A C) G); auto.
intros g x'; auto.
destruct (complete_option_cpo _ (fun n => G (c n) x) HchainG) as
  [[v'| ] Hlubv'].
destruct (chain_lub_some_witness1 C (fun n => G (c n) x) v' Hlubv')
  as [ n' HeqGcnx].
assert (Hlubtlx : lub (@option_cpo bool) (t l x) (fun n :nat => t (c n) x)).
apply (lub_lift_reverse A _ _ (fun n => t (c n))(t l) Hlubtl).
case (le_gt_dec n n').
intros Hnlen'.
assert (Heqcond : cond (t (c n') x)(F (c n') x)(G (c n') x) = Some v').
unfold cond.
assert (Heq' : t (c n') x = Some false).
apply option_chain_some_ge with (c:= (fun n=> t (c n) x))
  (n:= n) (m:= n'); auto.
intros n'';
  apply (continuous_imp_monotonic (A->option B)(A->option bool)
                (f_order A B) (f_order A bool) t 
                (f_order_reflexive A B) Hctt (c n'')(c (S n''))).
apply Hch.

rewrite Heq'.
assumption.
assert (HlubGl : lub (f_order A C) (G l) (fun n => G (c n))).
apply HctG; auto.
assert (Hopt :option_cpo (G (c n') x) (G l x)).
destruct HlubGl as [Hup _]; apply (Hup n').
rewrite HeqGcnx in Hopt; inversion Hopt.
rewrite <- Heqcond.
apply (Hup' n' x).

intros Hngtn'.
assert (Heqcond : cond (t (c n) x)(F (c n) x)(G (c n) x) = Some v').
unfold cond.
rewrite Heqtcnx.
apply option_chain_some_ge with (c:= (fun n => G (c n) x))
   (n:= n') (m:= n); auto.
auto with arith.
assert (HlubGl : lub (f_order A C) (G l) (fun n => G (c n))).
apply HctG; auto.
assert (Hopt :option_cpo (G (c n') x) (G l x)).
destruct HlubGl as [Hup _]; apply (Hup n').
rewrite HeqGcnx in Hopt; inversion Hopt.
rewrite <- Heqcond.
apply (Hup' n x).

assert (HlubGl : lub (f_order A C) (G l) (fun n => G (c n))).
apply HctG; auto.
assert (HlubGlx : lub (@option_cpo C) (G l x) (fun n => G (c n) x)).
apply (lub_lift_reverse A _ _ (fun n => G (c n))(G l) HlubGl).
assert (Heqflx_none : G l x = None).
apply unique_lub with (1:= antisym_option_cpo C)(2:= HlubGlx)(3:=Hlubv').
rewrite Heqflx_none; auto.
Qed.
    
Definition Apply (A B:Set)(f: option (A -> option B))(v:option A) : option B :=
  match v with
    Some x => match f with Some f' => f' x | None => None end
  | None => None
  end.

Implicit Arguments Apply.

Inductive option_cpo2 (A:Set)(R:A->A->Prop) : option A -> option A -> Prop:=
  opt_cpo2_inject : forall x y, R x y -> option_cpo2 A R (Some x)(Some y)
| opt_cpo2_none_bot : forall x, option_cpo2 A R None x.


Definition option_value (A B:Set)(f:A->option B)(v:option A): option B :=
   match v with Some x => f x | None => None end.

Theorem reflexive_option_cpo2 :
  forall (A:Set)(R:A->A->Prop),(forall x, R x x) ->
    forall v:option A, option_cpo2 A R v v.
intros A R H [v' |].
apply opt_cpo2_inject; auto.
apply opt_cpo2_none_bot.
Qed.


Theorem transitive_option_cpo2 :
  forall (A:Set)(R:A->A->Prop),
  (forall x y z, R x y -> R y z -> R x z) ->
  forall x y z:option A, option_cpo2 A R x y ->
      option_cpo2 A R y z -> option_cpo2 A R x z.
intros A R Ht x y z Hxy.
inversion Hxy.
intros Hyz.
inversion Hyz.
constructor; auto.
eapply Ht; eauto.
intros; constructor.
Qed.

Theorem option_cpo2_fun_chain_some_ge :
 forall (A B:Set)(R:A->A->Prop)(c:nat->option A),
 (forall n, option_cpo2 A R (c n) (c (S n))) ->
 (forall x, R x x) ->
 (forall x y z, R x y -> R y z -> R x z) ->
 forall n v, c n = Some v-> forall n', (n <= n')%nat ->
  (exists v', c n' = Some v' /\ R v v').
intros A B R c Hch Hrefl Htrans n v Heq n' Hle.
induction Hle.
exists v; auto.
assert (Hopt := Hch m).
destruct IHHle as [v1 [Heqv1 HRvv1]].
inversion Hopt.
rewrite Heqv1 in H;injection H; clear H; intros H.
subst x.
exists y;split;auto.
apply Htrans with v1; auto.
rewrite Heqv1 in H0;discriminate.
Qed.

Definition default_value (A:Set)(v:option A)(v':A) : A :=
  match v with Some w => w | None => v' end.

Implicit Arguments default_value.

Theorem complete_option_cpo2 :
  forall (A:Set)(R:A->A->Prop), (forall x, R x x) -> 
    (forall x y z, R x y -> R y z -> R x z) ->
    complete R ->
    complete (option_cpo2 A R).
intros A R Hr Ht Hc c Hch.
elim (classic (forall n, c n = None)).
intros Hnone; exists (@None A).
split.
intros n; rewrite (Hnone n); apply opt_cpo2_none_bot.
intros; apply opt_cpo2_none_bot.
intros Hnot_all.
destruct (@not_all_ex_not nat (fun n => c n = None) Hnot_all) as
  [n Hnot_none].
caseEq (c n); intros v Heq || intros Heq; try (elim Hnot_none; auto; fail).
assert (Hdefup : forall n', (n <= n')%nat -> c n' <> None).
intros n' Hle; induction Hle.
rewrite Heq; discriminate.
intros Habs.
assert (Hcmp:= Hch m).
apply IHHle.
rewrite Habs in Hcmp; inversion Hcmp; auto.
destruct (choice
                (fun n' y => ((n' < n)%nat -> y = v)/\
                             ((n <= n')%nat ->
                                  y = (default_value (c n') v))))
      as [newc Hnewc].
intros n'; case (le_gt_dec n n').
intros Hnlen'.
exists (default_value (c n') v).
split; intros.
assert (Habs : False).
omega.
elim Habs.
auto.
intros Hn'ltn; exists v;split;auto.
intros; assert (Habs : False).
omega.
contradiction.
destruct (Hnewc n) as [_ Hdefnewcn].
assert (Hchain' : forall n', R (newc n')(newc (S n'))).
intros n'; case (le_gt_dec n n').
intros Hnlen'; assert (Hstep := Hch n').
inversion Hstep.
destruct (Hnewc n') as [_ Hdefnewcn'].
rewrite Hdefnewcn';try omega.
destruct (Hnewc (S n')) as [_ Hdefnewcsn'].
rewrite Hdefnewcsn'; try omega.
rewrite <- H0; rewrite <- H; unfold default_value; auto.
elim (Hdefup n' Hnlen').
auto.
intros Hngtn'.
case (eq_nat_dec n (S n')).
intros Hneqsn'.
destruct (Hnewc n') as [Hdefnewcn' _]; rewrite Hdefnewcn'; try omega.
subst n.
destruct (Hnewc (S n')) as [_ Hdefnewcsn']; rewrite Hdefnewcsn'; try omega.
unfold default_value; rewrite Heq; auto.
intros HnneqSn'.
destruct (Hnewc n') as [Hdefnewcn' _]; rewrite Hdefnewcn'; try omega.
destruct (Hnewc (S n')) as [Hdefnewcsn' _]; rewrite Hdefnewcsn'; try omega.
auto.
destruct (Hc newc Hchain') as [l [Hup Hl]].
exists (Some l).
split.
intros n'.
assert (Hopt_R_n' := Hup n').
destruct (Hnewc n') as [Hdef1 Hdef2].
case (le_gt_dec n n').
intros Hnlen'.
rewrite Hdef2 in Hopt_R_n'; try omega.
assert (HnotNone := Hdefup n' Hnlen').
destruct (c n').
constructor; auto.
elim HnotNone; auto.
intros Hngtn'.
apply transitive_option_cpo2 with (y:= c n); auto.
apply chain_trans; auto.
apply transitive_option_cpo2; auto.
assert (Hcmpn := Hup n).
rewrite Hdefnewcn in Hcmpn; try omega.
rewrite Heq in Hcmpn; rewrite Heq.
constructor.
exact Hcmpn.
intros u Hu.
caseEq u.
intros u' Hequ'.
constructor.
apply Hl.

intros n'.
destruct (Hnewc n') as [Hdef1 Hdef2].
case (le_gt_dec n n').
intros Hnlen'.
rewrite Hdef2; auto.
assert (Hun' := Hu n').
subst u.
assert (Hnot_none' := Hdefup n' Hnlen').
destruct (c n').
simpl.
inversion Hun';auto.
elim Hnot_none'; auto.
intros Hngtn'.
rewrite Hdef1; try omega.
assert (Hun := Hu n).
rewrite Heq in Hun; rewrite Hequ' in Hun.
inversion Hun; auto.
intros Hunone.
assert (Hun := Hu n).
rewrite Hunone in Hun.
rewrite Heq in Hun; inversion Hun.
Qed.
Implicit Arguments option_value.

Theorem chain_lub_some_witness2 :
  forall (A B:Set)(c:nat -> option(A -> option B))(f:A -> option B),
    lub (option_cpo2 (A->option B)(f_order A B)) (Some f) c ->
    forall x v, f x = Some v ->
      exists n, exists g, c n = Some g /\ g x = Some v.
intros A B c f [Hup Hl] x v.
elim (classic (forall n, c n = None \/ 
                  (exists g, c n = Some g /\ g x = None))).
intros Hnone.
assert (Hwelldef :forall z, exists y:option B, 
                    ((x = z -> y = None) /\ (x <> z -> y = f z)) /\
                    forall y', ((x = z -> y'= None) /\ 
                    (x <> z -> y' = f z)) ->y=y').
intros z; case (classic (x = z)).
intros Heqxz; exists (@None B).
split.
split; intros H'.
auto.
elim H'; auto.
intros y; intuition.
intros Hneqxz; exists (f z).
split.
split; intros H'.
elim Hneqxz; auto.
auto.
intros y; intuition.
intros Heqfx.
assert (Hnewf :=
          dependent_description' A (fun _ => option B)
            (fun z y => (x = z -> y = None) /\ (x <> z -> y = f z))
            Hwelldef).
destruct Hnewf as [newf Hpropnewf].

assert (Hupnew :
         upper_bound (option_cpo2 (A -> option B)(f_order A B))(Some newf) c).
intros n.
caseEq (c n).
intros cn' Heqcn'.
constructor.
intros z; elim (classic (x = z)).
intros Heqxz; subst z.
elim (Hnone n).
rewrite Heqcn'.
intros; discriminate.
intros [cn2 [Heqcn2 Heq]]; rewrite Heqcn' in Heqcn2; injection Heqcn2.
intros; subst cn2; rewrite Heq; auto.
intros Hneqxz.
destruct (Hpropnewf z) as [_ Hp]; rewrite Hp; auto.
generalize (Hup n).
rewrite Heqcn'; intros Hopt2.
inversion Hopt2.
apply (H1 z).
intros; constructor.
assert (Hnone_aux1 : option_cpo (Some v) None).
rewrite <- Heqfx.
replace (@None B) with (newf x).
assert (Hopt2:= Hl (Some newf) Hupnew).
inversion Hopt2.
exact (H1 x).
elim (Hpropnewf x); auto.
inversion Hnone_aux1.
intros Hnot_all.
assert (Hex_not1 : exists n, exists g, c n = Some g /\ g x <> None).
apply not_all_not_ex with (U:=nat)
      (P:= fun n=> exists g, c n = Some g /\ g x <> None).
intros Hall_not_ex; apply Hnot_all; intros n; 
caseEq (c n).
auto.
intros g' Heqcn; right; exists g'; split; trivial.
caseEq (g' x).
auto.
intros v' Heqv'; elim (Hall_not_ex n); exists g'; split; auto.
rewrite Heqv'; discriminate.
auto.
auto.
intros Heq_fx_some.
destruct Hex_not1 as [n [g [Heqcn Heqg]]].
exists n; exists g; split; auto.
generalize (Hup n).
rewrite Heqcn; intros Hopt; inversion Hopt.
generalize (H1 x); rewrite Heq_fx_some.
intros Hopt2; inversion Hopt2.
rewrite <- H3 in Heqg; elim Heqg; auto.
auto.
Qed.

Theorem Apply_continuous :
  forall (A B C D : Set)(f:(A->option B)-> A->option (C->option D))
         (v:(A->option B)->A->option C),
    continuous (f_order A B)
        (lift_order A (option (C -> option D))
           (option_cpo2 (C->option D) (f_order C D))) f ->
    continuous (f_order A B)(f_order A C) v ->
    continuous (f_order A B)(f_order A D) 
          (fun g x => (Apply (f g x) (v g x))).
intros A B C D f v Hcf Hcv c Hch l Hlub.
assert (Hlubv := Hcv c Hch l Hlub).
assert (Hlubf := Hcf c Hch l Hlub).
split.
intros n x.
assert (Hlubvlx := lub_lift_reverse A (option C) (@option_cpo C)
                          (fun n => (v (c n)))(v l) Hlubv x).
assert (Hopt: option_cpo (v (c n) x)(v l x)).
destruct Hlubvlx as [Hupvlx _]; exact (Hupvlx n).
assert (Hlubflx := lub_lift_reverse A (option (C -> option D))
                         (option_cpo2 (C->option D)(f_order C D))
                          (fun n => (f (c n)))(f l) Hlubf x).
assert (Hopt2: option_cpo2 (C->option D)(f_order C D) (f (c n) x) (f l x)).
destruct Hlubflx as [Hupflx _]; exact (Hupflx n).
unfold Apply.
inversion Hopt; auto.
destruct (v (c n) x); auto.
inversion Hopt2; auto.
intros u Hu.
intros x.
assert (Hlubvlx := lub_lift_reverse A (option C) (@option_cpo C)
                          (fun n => (v (c n)))(v l) Hlubv x).
assert (Hlubflx := lub_lift_reverse A (option (C -> option D))
                         (option_cpo2 (C->option D)(f_order C D))
                          (fun n => (f (c n)))(f l) Hlubf x).
caseEq (v l x).
intros v' Heqvlx.
caseEq (f l x).
intros f' Heqflx.
simpl.
destruct (chain_lub_some_witness1 C (fun n => v (c n) x) v') as
  [n2 Hn2].
rewrite <- Heqvlx; assumption.
assert (Hch' : forall n, lift_order A (option (C->option D))
                  (option_cpo2 _ (f_order C D))(f (c n))(f (c (S n)))).
intros n.
apply (continuous_imp_monotonic _ _ (f_order A B)
                   (lift_order A _ (option_cpo2 _(f_order C D)))
                   f (f_order_reflexive A B) Hcf (c n) (c (S n))) .
apply Hch.
assert (Hlubonv' : exists r, lub (@option_cpo D) r
            (fun n => Apply (f (c n) x) (Some v'))).
unfold Apply.
apply (complete_option_cpo D).
intros n.
assert (Hch2: option_cpo2 _ (f_order C D) (f (c n) x)(f (c (S n)) x)).
apply (Hch' n x).
inversion Hch2.
apply (H1 v').
auto.
destruct Hlubonv' as [r Hlubr].
caseEq r.
intros r' Heqr'.
destruct (chain_lub_some_witness1 D (fun n => Apply (f (c n) x)(Some v')) r')
  as [n4 Hn4].
rewrite <- Heqr'; assumption.
assert (Hex_n3 : exists n, Apply (f (c n) x) (Some v') = Some r' /\
                  v (c n) x = Some v').
case (le_gt_dec n2 n4).
intros Hn2len4.
exists n4; split; auto.
apply option_chain_some_ge with (c:= fun n => v (c n) x)(n:= n2);auto.
intros n.
apply (continuous_imp_monotonic _ _ (f_order A B)(f_order A C) v
          (f_order_reflexive A B) Hcv (c n) (c (S n))).
apply Hch.
intros Hn2gtn4.
caseEq (f (c n4) x).
intros f4 Heqf4.
exists n2; split; auto.
elim (option_cpo2_fun_chain_some_ge (C ->option D)
                     (C->option D) (f_order C D) (fun n => f (c n) x)
              (fun n => (Hch' n x))) with
         (n := n4)(n' := n2)(v := f4).
intros gn2 [Heqgn2 Hcmpgn2].
rewrite Heqgn2.
assert (Hoptgn2 : option_cpo (f4 v')(gn2 v')).
apply (Hcmpgn2 v').
simpl.
rewrite Heqf4 in Hn4.
simpl in Hn4.
rewrite Hn4 in Hoptgn2; inversion Hoptgn2; auto.
apply f_order_reflexive.
unfold f_order; apply lift_transitive.
apply transitive_option_cpo.
assumption.
omega.
intros Hfcn4_none; rewrite Hfcn4_none in Hn4; simpl in Hn4; discriminate Hn4.
destruct Hex_n3 as [n3 [Heq1 Heq2]].
assert (Hopt_D :option_cpo (Some r') (f' v')).
rewrite <- Heq1.
destruct Hlubflx as [Hup _].
rewrite Heqflx in Hup.
assert (Hup3 := Hup n3).
simpl in Hup3.
caseEq (f (c n3) x).
intros g3 Heqg3.
rewrite Heqg3 in Hup3.
inversion Hup3;auto.
apply (H1 v').
simpl; auto.
assert (Heqf'v' : Some r' = f' v').
inversion Hopt_D; auto.
rewrite <- Heqf'v'; rewrite <- Heq1.
rewrite <- Heq2.
apply (Hu n3 x).
intros Hrnone.

destruct Hlubflx as [Hupflx Hlflx].
destruct (choice
             (fun z y => (z = v' -> y = None) /\ (z <> v' -> y = f' z))) as
   [f'' Hf''].
intros e; case (classic (e = v')).
intros Heqev'; exists (@None D); split; intuition.
intros Hneqev'; exists (f' e); split; intuition.
assert (Hopt: option_cpo2 (C -> option D)(f_order C D)(f l x)(Some f'')).
apply Hlflx.
intros n.
caseEq (f (c n) x).
intros a Heqa.
constructor.
intros e; case (classic (e = v')).
intros Heqev'.
destruct (Hf'' e) as [Hdef1 _].
rewrite Hdef1; auto.
destruct Hlubr as [Hupr _].
replace (a e) with (Apply (f (c n) x)(Some v')).
rewrite <- Hrnone.
apply (Hupr n).
rewrite Heqa; rewrite <- Heqev'; auto.
intros Hneqev'.
destruct (Hf'' e) as [_ Hdef2].
rewrite Hdef2; auto.
assert (Hopt2 := Hupflx n).
lazy beta in Hopt2.
rewrite Heqa in Hopt2; rewrite Heqflx in Hopt2; inversion Hopt2.
apply (H1 e).
intros; constructor.
rewrite Heqflx in Hopt; inversion Hopt.
assert (Hopt3 := H1 v').
destruct (Hf'' v') as [Hdef1 _]; rewrite Hdef1 in Hopt3; auto.
inversion Hopt3; auto.
rewrite H4; auto.
simpl; auto.
simpl; auto.
Qed.

Theorem option_cpo2_reflexive :
  forall (A:Set)(R:A->A->Prop), (forall x, R x x) ->
  forall y, option_cpo2 A R y y.
intros; case y; intros.
apply opt_cpo2_inject; auto.
apply opt_cpo2_none_bot.
Qed.

Theorem continuous_id :
   forall A B, continuous (f_order A B)
                  (lift_order A (option (A -> option B))
                     (option_cpo2 (A -> option B)
                         (f_order A B)))
          (fun g x => Some g).
intros A B c Hch l Hlub; split.
intros n x; apply opt_cpo2_inject.
destruct Hlub as [Hup _]; apply (Hup n).


intros l' Hup x.
caseEq (l' x).
intros v Heqv.
constructor.
destruct Hlub as [Hupl Hll].
apply Hll.
intros n.
assert (Hcmp := Hup n x).
rewrite Heqv in Hcmp; inversion Hcmp; auto.
intros Heql'xNone.
assert (Hcmp := Hup 0%nat x).
rewrite Heql'xNone in Hcmp; inversion Hcmp.
Qed.

Definition F_fact : (Z -> option Z) -> Z -> option Z :=
   fun f z =>
     cond (Some (Zeq_bool z 0))
        (Some 1)
        (Apply (Some (fun v => Some (z*v))) (f (z - 1))).

Theorem F_fact_continuous : 
    continuous (f_order Z Z)(f_order Z Z) F_fact.
apply (cond_continuous Z Z Z (fun f z => Some (Zeq_bool z 0))
           (fun f z => Some 1)
           (fun f z => Apply (Some (fun v => Some (z*v))) (f (z-1)))).
apply (continuous_cst (Z->option Z)(Z->option bool)
          (f_order Z Z)(f_order Z bool) (fun z => Some (Zeq_bool z 0))).
apply f_order_reflexive.
apply (continuous_cst (Z->option Z)(Z->option Z)
          (f_order Z Z)(f_order Z Z) (fun _ => Some 1)).
apply f_order_reflexive.
apply (Apply_continuous Z Z Z Z (fun g z => Some (fun v => (Some (z*v))))
         (fun g z => g (z - 1))).
apply continuous_cst.
intros f x.
apply option_cpo2_reflexive.
intros g y; auto.
apply (Apply_continuous Z Z Z Z
         (fun g z => Some g)(fun g z => Some (z - 1))).  
apply continuous_id.
apply continuous_cst.
apply f_order_reflexive.
Qed.

Definition fact : Z -> option Z :=
  Tarski_fix F_fact F_fact_continuous.

Definition F_fact2 : (Z -> option Z) -> Z -> option Z :=
   fun f z =>
     cond (Some (Zeq_bool z 0))
        (Some 1)
        (Apply (Some (fun v => Some (z*v))) (f (z - 1))).

Theorem F_fact_neg_aux :
  forall n, forall x, x < 0 -> iter _ F_fact n (fun z => None) x = None.
induction n.
simpl; auto.
simpl; intros x Hneg; unfold F_fact at 1.
generalize (Zlt_compare x 0 Hneg).
unfold Zeq_bool.
case (x?=0); intros; try contradiction.
rewrite IHn.
trivial.
omega.
Qed.

Theorem fact_neg_none :
  forall x, x < 0 -> fact x = None.
intros x Hneg; unfold fact; apply iterates_none_imp_fix_none.
intros n; apply F_fact_neg_aux; auto.
Qed.

Extract Constant Tarski_fix => "let rec t f x = f (fun y -> t f y) x in t".

Extraction "fact.ml" fact.
